/* EDIT by Sir D.:
 - removed plugin_connect and disconnect
 - removed timer
 - added specmode as registered command.
*/

#include <core>
#include <string>
#include <admin>
#include <adminlib>

#define DEBUG 0
#define ACCESS_ENTRYSOUND 512
#define MAX_ENTRYS 40


new CfgFile[]="addons/adminmod/config/usersounds.cfg";            //contains ':'-seperated list: wonid:path/to/soundfile.wav:Some cool text announcing the admin

new STRING_VERSION[MAX_DATA_LENGTH] = "1.0";

new strAuthID[MAX_ENTRYS][MAX_AUTHID_LENGTH];
new Sounds[MAX_ENTRYS][50];
new Texts[MAX_ENTRYS][100];
new g_loaded;

new bPluginEnabled = 0;                    //will be enabled in plugin_init() 

new g_User[MAX_PLAYERS];


public plugin_init()
{
	plugin_registerinfo("Bib's entrysound-plugin","Announces admins with text and sound.",STRING_VERSION);
	plugin_registercmd("admin_entrysound","admin_entrysound",ACCESS_ENTRYSOUND,"admin_entrysound <1|0> : enables/disables sounds.");
	plugin_registercmd("specmode","specmode",ACCESS_ALL);
	parse_cfg();
	if(!get_vaultnumdata("ENTRYSOUND_ENABLED",bPluginEnabled)){
		set_vaultnumdata("ENTRYSOUND_ENABLED",1);
	}
	return PLUGIN_CONTINUE;
}

public specmode(HLCommand,HLData,HLUserName,UserIndex){
	if(!g_User[UserIndex] && bPluginEnabled){
		new User[MAX_NAME_LENGTH];
		new AuthID[MAX_AUTHID_LENGTH];
		g_User[UserIndex]=1;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		get_userAuthID(User,AuthID,MAX_AUTHID_LENGTH);
		announce(AuthID);
	}
	return PLUGIN_CONTINUE;
}		

announce(sAuthID[])
{
	new i=0;
	for (i=0; i<=g_loaded; i++)
	{
		if (strcmp(strAuthID[i],sAuthID)==0)
		{
			centersay(Texts[i],20,255,10,10);
			playsoundall(Sounds[i]);
			break;
		}
	}
}

public admin_entrysound(HLCommand,HLData,HLUserName,UserIndex)
{
	new data[MAX_DATA_LENGTH];
	convert_string(HLData,data,MAX_DATA_LENGTH);
	strtrim(data," ",2);
	if (data[0]=='1')
	{
		bPluginEnabled = 1;
		selfmessage("Bib Entrysound Plugin has been enabled!");
		set_vaultnumdata("ENTRYSOUND_ENABLED",bPluginEnabled);
	}
	else if (strncmp(data,"0",1)==0)
	{
		bPluginEnabled = 0;
		selfmessage("Bib Entrysound Plugin has been disabled!");
		set_vaultnumdata("ENTRYSOUND_ENABLED",bPluginEnabled);
	}
	else
	{
		selfmessage("admin_entrysound <1|0> : enables/disables sounds.");
	}
	return PLUGIN_HANDLED;
}

stock playsoundall(sound[])
{
	new maxplayers = maxplayercount();
	new Name[MAX_NAME_LENGTH];
	new i;

	for(i=1; i<=maxplayers; i++)
	{
		if (playerinfo(i, Name, MAX_NAME_LENGTH) == 1)
		{
			speakto(Name, sound);
		}
	}
}

parse_cfg()
{
	new strLine[MAX_TEXT_LENGTH];
	new LineNo=0;
	new i=0;
	
	if (fileexists(CfgFile))
	{
		LineNo=filesize(CfgFile);
		
		if(LineNo >= MAX_ENTRYS){
			LineNo = MAX_ENTRYS-1;
		}

		for (i=1;i<=LineNo;i++)
		{
			readfile(CfgFile,strLine,i,MAX_TEXT_LENGTH);
			
			if (strncmp(strLine, "#", 1) != 0 && strncmp(strLine, "//", 2) != 0)
			{
				strsep(strLine,"%",strAuthID[g_loaded],MAX_AUTHID_LENGTH,Sounds[g_loaded],50,Texts[g_loaded],MAX_TEXT_LENGTH);
				g_loaded++;
			}
		}
		g_loaded--;
	}
	else
	{
		selfmessage("ERROR: Entrysound-Plugin: Configfile not found!");
	}
}